#include <fstream>
#include <stack>

#define MAXN 100001

using namespace std;

ifstream in("codat.in");
ofstream out("codat.out");

int abs(int x)
{
	if(x<0) x*=-1;
	return x;
}

stack <int> st;
int v[MAXN];
int idx[MAXN];

int main()
{
	int N;
	in>>N;

	for(int i=1;i<=N;++i) in>>v[i];

	for(int i=1;i<=N;++i)
	{
		while(!st.empty()&&v[st.top()]<=v[i]) st.pop();

		if(st.empty()) idx[i]=-1;
		else idx[i]=st.top();

		st.push(i);
	}

	while(!st.empty()) st.pop();

	for(int i=N;i>=1;--i)
	{
		while(!st.empty()&&v[st.top()]<=v[i]) st.pop();

		if(!st.empty())
			if(idx[i]==-1||abs(idx[i]-i)>=abs(st.top()-i)) idx[i]=st.top();

		st.push(i);
	}

	for(int i=1;i<=N;++i)
		out<<idx[i]<<' ';
	out<<'\n';

	in.close();
	out.close();

	return 0;
}
